/* C code produced by gperf version 2.7.2 */
/* Command-line: gperf -C -c -S 1 -D -k '1,3,5,$' -t ./keyword.gperf  */
/* Autogenrated. */
#include "ksi.h"
struct ksi_keyword { const char *name; keyword_t id; };
#ifdef __GNUC__
__inline
#endif
static unsigned int hash(register const char *, 
			 register unsigned int);
#ifdef __GNUC__
__inline
#endif
static const struct ksi_keyword *in_word_set(register const char *, 
					     register unsigned int);

#define TOTAL_KEYWORDS 134
#define MIN_WORD_LENGTH 2
#define MAX_WORD_LENGTH 21
#define MIN_HASH_VALUE 18
#define MAX_HASH_VALUE 660
/* maximum key range = 643, duplicates = 2 */

#ifdef __GNUC__
__inline
#else
#ifdef __cplusplus
inline
#endif
#endif
static unsigned int
hash (str, len)
     register const char *str;
     register unsigned int len;
{
  static const unsigned short asso_values[] =
    {
      661, 661, 661, 661, 661, 661, 661, 661, 661, 661,
      661, 661, 661, 661, 661, 661, 661, 661, 661, 661,
      661, 661, 661, 661, 661, 661, 661, 661, 661, 661,
      661, 661, 661, 661, 661, 661, 661, 661, 661, 661,
      661, 661, 661, 661, 661, 661, 661, 661, 661, 661,
      661, 661, 661, 661, 661, 661, 661, 661, 661, 661,
      661, 661, 661, 661, 661, 661, 661, 661, 661, 661,
      661, 661, 661, 661, 661, 661, 661, 661, 661, 661,
      661, 661, 661, 661, 661, 661, 661, 661, 661, 661,
      661, 661, 661, 661, 661,  90, 661, 160, 160,   0,
       80,  65,  60,  40, 180,  15, 661,  20, 165,  55,
       25, 105, 135,  45, 253,   0,   0,   5,  55,   5,
       70,   5,   5, 661, 661, 661, 661, 661, 661, 661,
      661, 661, 661, 661, 661, 661, 661, 661, 661, 661,
      661, 661, 661, 661, 661, 661, 661, 661, 661, 661,
      661, 661, 661, 661, 661, 661, 661, 661, 661, 661,
      661, 661, 661, 661, 661, 661, 661, 661, 661, 661,
      661, 661, 661, 661, 661, 661, 661, 661, 661, 661,
      661, 661, 661, 661, 661, 661, 661, 661, 661, 661,
      661, 661, 661, 661, 661, 661, 661, 661, 661, 661,
      661, 661, 661, 661, 661, 661, 661, 661, 661, 661,
      661, 661, 661, 661, 661, 661, 661, 661, 661, 661,
      661, 661, 661, 661, 661, 661, 661, 661, 661, 661,
      661, 661, 661, 661, 661, 661, 661, 661, 661, 661,
      661, 661, 661, 661, 661, 661, 661, 661, 661, 661,
      661, 661, 661, 661, 661, 661
    };
  register int hval = len;

  switch (hval)
    {
      default:
      case 5:
        hval += asso_values[(unsigned char)str[4]];
      case 4:
      case 3:
        hval += asso_values[(unsigned char)str[2]];
      case 2:
      case 1:
        hval += asso_values[(unsigned char)str[0]];
        break;
    }
  return hval + asso_values[(unsigned char)str[len - 1]];
}

#ifdef __GNUC__
__inline
#endif
const struct ksi_keyword *
in_word_set (str, len)
     register const char *str;
     register unsigned int len;
{
  static const struct ksi_keyword wordlist[] =
    {
      {"int", kw_int},
      {"const", kw_const},
      {"uint", kw_uint},
      {"const_func", kw_const_func},
      {"gt", kw_gt},
      {"section", kw_section},
      {"ungt", kw_ungt},
      {"ffs", kw_ffs},
      {"trunc_div", kw_trunc_div},
      {"union", kw_union},
      {"try_finally", kw_try_finally},
      {"exit", kw_exit},
      {"minus", kw_minus},
      {"elipsis", kw_elipsis},
      {"func", kw_func},
      {"ne", kw_ne},
      {"constdef", kw_constdef},
      {"constref", kw_constref},
      {"trunc_mod", kw_trunc_mod},
      {"convert", kw_convert},
      {"ge", kw_ge},
      {"min", kw_min},
      {"cond", kw_cond},
      {"eq", kw_eq},
      {"uniondef", kw_uniondef},
      {"unge", kw_unge},
      {"uneq", kw_uneq},
      {"enum", kw_enum},
      {"negate", kw_negate},
      {"fix_trunc", kw_fix_trunc},
      {"plus", kw_plus},
      {"goto", kw_goto},
      {"void", kw_void},
      {"postinc", kw_postinc},
      {"size_of", kw_size_of},
      {"abs", kw_abs},
      {"no_limit_stack", kw_no_limit_stack},
      {"lt", kw_lt},
      {"ceil_div", kw_ceil_div},
      {"component", kw_component},
      {"float", kw_float},
      {"unlt", kw_unlt},
      {"alias_set", kw_alias_set},
      {"alias_subset", kw_alias_subset},
      {"weak", kw_weak},
      {"bit_not", kw_bit_not},
      {"ceil_mod", kw_ceil_mod},
      {"truth_not", kw_truth_not},
      {"max", kw_max},
      {"tydef", kw_tydef},
      {"modify", kw_modify},
      {"builtin", kw_builtin},
      {"no_return", kw_no_return},
      {"enumdef", kw_enumdef},
      {"comdat", kw_comdat},
      {"postdec", kw_postdec},
      {"mult", kw_mult},
      {"input_file", kw_input_file},
      {"preinc", kw_preinc},
      {"le", kw_le},
      {"unle", kw_unle},
      {"func_ref", kw_func_ref},
      {"compound", kw_compound},
      {"truth_orif", kw_truth_orif},
      {"truth_andif", kw_truth_andif},
      {"struct", kw_struct},
      {"fbuiltin", kw_fbuiltin},
      {"bind", kw_bind},
      {"predec", kw_predec},
      {"truth_and", kw_truth_and},
      {"unordered", kw_unordered},
      {"packed", kw_packed},
      {"aligned", kw_aligned},
      {"one_only", kw_one_only},
      {"exact_div", kw_exact_div},
      {"non_lvalue", kw_non_lvalue},
      {"nop", kw_nop},
      {"fix_ceil", kw_fix_ceil},
      {"poly", kw_poly},
      {"block", kw_block},
      {"exit_loop", kw_exit_loop},
      {"public", kw_public},
      {"structdef", kw_structdef},
      {"rdiv", kw_rdiv},
      {"bit_andtc", kw_bit_andtc},
      {"call", kw_call},
      {"wfl", kw_wfl},
      {"extern", kw_extern},
      {"debug_name", kw_debug_name},
      {"indirect", kw_indirect},
      {"nil", kw_nil},
      {"ellipsis", kw_ellipsis},
      {"ref", kw_ref},
      {"tyref", kw_tyref},
      {"no_check_memory_usage", kw_no_check_memory_usage},
      {"artificial", kw_artificial},
      {"malloc_like", kw_malloc_like},
      {"round_div", kw_round_div},
      {"bit_and", kw_bit_and},
      {"loop", kw_loop},
      {"lshift", kw_lshift},
      {"result", kw_result},
      {"round_mod", kw_round_mod},
      {"float_expr", kw_float_expr},
      {"bool", kw_bool},
      {"bit_ior", kw_bit_ior},
      {"func_ptr", kw_func_ptr},
      {"static_var", kw_static_var},
      {"static_ctor", kw_static_ctor},
      {"static_dtor", kw_static_dtor},
      {"suppress_debug", kw_suppress_debug},
      {"truth_or", kw_truth_or},
      {"truth_xor", kw_truth_xor},
      {"fix_floor", kw_fix_floor},
      {"fix_round", kw_fix_round},
      {"global", kw_global},
      {"floor_div", kw_floor_div},
      {"pure_func", kw_pure_func},
      {"bit_xor", kw_bit_xor},
      {"addr", kw_addr},
      {"rshift", kw_rshift},
      {"local", kw_local},
      {"lrotate", kw_lrotate},
      {"floor_mod", kw_floor_mod},
      {"ordered", kw_ordered},
      {"return", kw_return},
      {"fcall", kw_fcall},
      {"ptr_call", kw_ptr_call},
      {"var", kw_var},
      {"rrotate", kw_rrotate},
      {"ptr_fcall", kw_ptr_fcall},
      {"reference", kw_reference},
      {"ptr", kw_ptr},
      {"label", kw_label}
    };

  if (len <= MAX_WORD_LENGTH && len >= MIN_WORD_LENGTH)
    {
      register int key = hash (str, len);

      if (key <= MAX_HASH_VALUE && key >= MIN_HASH_VALUE)
        {
          register const struct ksi_keyword *wordptr;
          register const struct ksi_keyword *wordendptr;
          register const struct ksi_keyword *resword;

          switch (key - 18)
            {
              case 0:
                resword = &wordlist[0];
                goto compare;
              case 12:
                resword = &wordlist[1];
                goto compare;
              case 16:
                resword = &wordlist[2];
                goto compare;
              case 17:
                resword = &wordlist[3];
                goto compare;
              case 24:
                resword = &wordlist[4];
                goto compare;
              case 29:
                resword = &wordlist[5];
                goto compare;
              case 31:
                resword = &wordlist[6];
                goto compare;
              case 45:
                resword = &wordlist[7];
                goto compare;
              case 51:
                resword = &wordlist[8];
                goto compare;
              case 57:
                resword = &wordlist[9];
                goto compare;
              case 63:
                resword = &wordlist[10];
                goto compare;
              case 66:
                resword = &wordlist[11];
                goto compare;
              case 67:
                resword = &wordlist[12];
                goto compare;
              case 69:
                resword = &wordlist[13];
                goto compare;
              case 71:
                resword = &wordlist[14];
                goto compare;
              case 74:
                resword = &wordlist[15];
                goto compare;
              case 75:
                wordptr = &wordlist[16];
                wordendptr = wordptr + 2;
                goto multicompare;
              case 76:
                resword = &wordlist[18];
                goto compare;
              case 79:
                resword = &wordlist[19];
                goto compare;
              case 89:
                resword = &wordlist[20];
                goto compare;
              case 90:
                resword = &wordlist[21];
                goto compare;
              case 91:
                resword = &wordlist[22];
                goto compare;
              case 94:
                resword = &wordlist[23];
                goto compare;
              case 95:
                resword = &wordlist[24];
                goto compare;
              case 96:
                resword = &wordlist[25];
                goto compare;
              case 101:
                resword = &wordlist[26];
                goto compare;
              case 111:
                resword = &wordlist[27];
                goto compare;
              case 118:
                resword = &wordlist[28];
                goto compare;
              case 121:
                resword = &wordlist[29];
                goto compare;
              case 126:
                resword = &wordlist[30];
                goto compare;
              case 131:
                resword = &wordlist[31];
                goto compare;
              case 136:
                resword = &wordlist[32];
                goto compare;
              case 139:
                resword = &wordlist[33];
                goto compare;
              case 144:
                resword = &wordlist[34];
                goto compare;
              case 145:
                resword = &wordlist[35];
                goto compare;
              case 146:
                resword = &wordlist[36];
                goto compare;
              case 149:
                resword = &wordlist[37];
                goto compare;
              case 150:
                resword = &wordlist[38];
                goto compare;
              case 151:
                resword = &wordlist[39];
                goto compare;
              case 152:
                resword = &wordlist[40];
                goto compare;
              case 156:
                resword = &wordlist[41];
                goto compare;
              case 166:
                resword = &wordlist[42];
                goto compare;
              case 169:
                resword = &wordlist[43];
                goto compare;
              case 171:
                resword = &wordlist[44];
                goto compare;
              case 174:
                resword = &wordlist[45];
                goto compare;
              case 175:
                resword = &wordlist[46];
                goto compare;
              case 176:
                resword = &wordlist[47];
                goto compare;
              case 180:
                resword = &wordlist[48];
                goto compare;
              case 187:
                resword = &wordlist[49];
                goto compare;
              case 188:
                resword = &wordlist[50];
                goto compare;
              case 189:
                resword = &wordlist[51];
                goto compare;
              case 196:
                resword = &wordlist[52];
                goto compare;
              case 199:
                resword = &wordlist[53];
                goto compare;
              case 203:
                resword = &wordlist[54];
                goto compare;
              case 204:
                resword = &wordlist[55];
                goto compare;
              case 206:
                resword = &wordlist[56];
                goto compare;
              case 207:
                resword = &wordlist[57];
                goto compare;
              case 213:
                resword = &wordlist[58];
                goto compare;
              case 214:
                resword = &wordlist[59];
                goto compare;
              case 221:
                resword = &wordlist[60];
                goto compare;
              case 225:
                resword = &wordlist[61];
                goto compare;
              case 230:
                resword = &wordlist[62];
                goto compare;
              case 237:
                resword = &wordlist[63];
                goto compare;
              case 238:
                resword = &wordlist[64];
                goto compare;
              case 241:
                resword = &wordlist[65];
                goto compare;
              case 245:
                resword = &wordlist[66];
                goto compare;
              case 251:
                resword = &wordlist[67];
                goto compare;
              case 253:
                resword = &wordlist[68];
                goto compare;
              case 256:
                resword = &wordlist[69];
                goto compare;
              case 261:
                resword = &wordlist[70];
                goto compare;
              case 268:
                resword = &wordlist[71];
                goto compare;
              case 269:
                resword = &wordlist[72];
                goto compare;
              case 270:
                resword = &wordlist[73];
                goto compare;
              case 271:
                resword = &wordlist[74];
                goto compare;
              case 272:
                resword = &wordlist[75];
                goto compare;
              case 280:
                resword = &wordlist[76];
                goto compare;
              case 285:
                resword = &wordlist[77];
                goto compare;
              case 291:
                resword = &wordlist[78];
                goto compare;
              case 292:
                resword = &wordlist[79];
                goto compare;
              case 296:
                resword = &wordlist[80];
                goto compare;
              case 298:
                resword = &wordlist[81];
                goto compare;
              case 304:
                resword = &wordlist[82];
                goto compare;
              case 309:
                resword = &wordlist[83];
                goto compare;
              case 311:
                resword = &wordlist[84];
                goto compare;
              case 316:
                resword = &wordlist[85];
                goto compare;
              case 320:
                resword = &wordlist[86];
                goto compare;
              case 331:
                resword = &wordlist[87];
                goto compare;
              case 337:
                resword = &wordlist[88];
                goto compare;
              case 338:
                resword = &wordlist[89];
                goto compare;
              case 340:
                resword = &wordlist[90];
                goto compare;
              case 355:
                resword = &wordlist[91];
                goto compare;
              case 358:
                resword = &wordlist[92];
                goto compare;
              case 360:
                resword = &wordlist[93];
                goto compare;
              case 363:
                resword = &wordlist[94];
                goto compare;
              case 377:
                resword = &wordlist[95];
                goto compare;
              case 383:
                resword = &wordlist[96];
                goto compare;
              case 384:
                resword = &wordlist[97];
                goto compare;
              case 389:
                resword = &wordlist[98];
                goto compare;
              case 391:
                resword = &wordlist[99];
                goto compare;
              case 393:
                resword = &wordlist[100];
                goto compare;
              case 406:
                resword = &wordlist[101];
                goto compare;
              case 409:
                resword = &wordlist[102];
                goto compare;
              case 410:
                resword = &wordlist[103];
                goto compare;
              case 416:
                resword = &wordlist[104];
                goto compare;
              case 417:
                resword = &wordlist[105];
                goto compare;
              case 418:
                resword = &wordlist[106];
                goto compare;
              case 420:
                resword = &wordlist[107];
                goto compare;
              case 421:
                wordptr = &wordlist[108];
                wordendptr = wordptr + 2;
                goto multicompare;
              case 424:
                resword = &wordlist[110];
                goto compare;
              case 428:
                resword = &wordlist[111];
                goto compare;
              case 429:
                resword = &wordlist[112];
                goto compare;
              case 434:
                resword = &wordlist[113];
                goto compare;
              case 454:
                resword = &wordlist[114];
                goto compare;
              case 458:
                resword = &wordlist[115];
                goto compare;
              case 464:
                resword = &wordlist[116];
                goto compare;
              case 469:
                resword = &wordlist[117];
                goto compare;
              case 472:
                resword = &wordlist[118];
                goto compare;
              case 479:
                resword = &wordlist[119];
                goto compare;
              case 481:
                resword = &wordlist[120];
                goto compare;
              case 482:
                resword = &wordlist[121];
                goto compare;
              case 484:
                resword = &wordlist[122];
                goto compare;
              case 489:
                resword = &wordlist[123];
                goto compare;
              case 507:
                resword = &wordlist[124];
                goto compare;
              case 519:
                resword = &wordlist[125];
                goto compare;
              case 537:
                resword = &wordlist[126];
                goto compare;
              case 543:
                resword = &wordlist[127];
                goto compare;
              case 546:
                resword = &wordlist[128];
                goto compare;
              case 572:
                resword = &wordlist[129];
                goto compare;
              case 604:
                resword = &wordlist[130];
                goto compare;
              case 622:
                resword = &wordlist[131];
                goto compare;
              case 626:
                resword = &wordlist[132];
                goto compare;
              case 642:
                resword = &wordlist[133];
                goto compare;
            }
          return 0;
        multicompare:
          while (wordptr < wordendptr)
            {
              register const char *s = wordptr->name;

              if (*str == *s && !strncmp (str + 1, s + 1, len - 1) && s[len] == '\0')
                return wordptr;
              wordptr++;
            }
          return 0;
        compare:
          {
            register const char *s = resword->name;

            if (*str == *s && !strncmp (str + 1, s + 1, len - 1) && s[len] == '\0')
              return resword;
          }
        }
    }
  return 0;
}

static const char *keyword_names[] = {
	"ERROR",
	"abs",
	"addr",
	"aligned",
	"artificial",
	"bind",
	"bit_and",
	"bit_andtc",
	"bit_ior",
	"bit_not",
	"bit_xor",
	"block",
	"bool",
	"builtin",
	"call",
	"ceil_div",
	"ceil_mod",
	"comdat",
	"component",
	"compound",
	"cond",
	"const",
	"const_func",
	"convert",
	"elipsis",
	"ellipsis",
	"enum",
	"enumdef",
	"eq",
	"exact_div",
	"exit",
	"exit_loop",
	"extern",
	"fbuiltin",
	"fcall",
	"ffs",
	"float",
	"float_expr",
	"floor_div",
	"floor_mod",
	"func",
	"func_ptr",
	"func_ref",
	"ge",
	"global",
	"goto",
	"gt",
	"indirect",
	"input_file",
	"int",
	"label",
	"le",
	"local",
	"loop",
	"lrotate",
	"lshift",
	"lt",
	"malloc_like",
	"max",
	"min",
	"minus",
	"modify",
	"mult",
	"ne",
	"negate",
	"no_check_memory_usage",
	"no_limit_stack",
	"no_return",
	"non_lvalue",
	"nop",
	"one_only",
	"ordered",
	"packed",
	"plus",
	"ptr",
	"ptr_call",
	"ptr_fcall",
	"public",
	"pure_func",
	"rdiv",
	"ref",
	"result",
	"return",
	"round_div",
	"round_mod",
	"rrotate",
	"rshift",
	"section",
	"static_ctor",
	"static_dtor",
	"static_var",
	"struct",
	"structdef",
	"suppress_debug",
	"trunc_div",
	"trunc_mod",
	"truth_and",
	"truth_andif",
	"truth_not",
	"truth_or",
	"truth_orif",
	"truth_xor",
	"uint",
	"uneq",
	"unge",
	"ungt",
	"union",
	"uniondef",
	"unle",
	"unlt",
	"unordered",
	"var",
	"void",
	"weak",
	"wfl",
	"fix_trunc",
	"fix_ceil",
	"fix_round",
	"fix_floor",
	"preinc",
	"postinc",
	"predec",
	"postdec",
	"size_of",
	"try_finally",
	"debug_name",
	"alias_set",
	"constdef",
	"constref",
	"reference",
	"tydef",
	"tyref",
	"poly",
	"alias_subset",
	"nil",
	0
};

const char *keyword_name(keyword_t kw)
{
	int k = (int)kw;

	if (k <= kw__error || k >= kw__LAST)
		return keyword_names[0];
	else
		return keyword_names[kw];
}

keyword_t lookup_keyword(const char *ptr, int len)
{
	const struct ksi_keyword *w;

	w = in_word_set(ptr, len);

	if (w)
		return w->id;
	else
		return kw__error;
}
